// Doom to Delphi Total Conversion
// Author: Jim Valavanis
// E-Mail: jimmyvalavanis@yahoo.gr
// Site  : http://www.geocities.com/jimmyvalavanis/applications/delphidoom.html

unit i_main;

interface

uses Windows,
    d_delphi;

{
    i_main.c
}

// Emacs style mode select   -*- C++ -*-  
//----------------------------------------------------------------------------- 
// 
// $Id:$ 
// 
// Copyright (C) 1993-1996 by id Software, Inc. 
// 
// This source is available for distribution and/or modification 
// only under the terms of the DOOM Source Code License as 
// published by id Software. All rights reserved. 
// 
// The source is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License 
// for more details. 
// 
// DESCRIPTION: 
//   Main program, simply calls D_DoomMain high level loop. 
//  
//----------------------------------------------------------------------------- 

var
  hMainWnd: HWND = 0;

const
  AppTitle = 'Delphi Doom';

procedure DoomMain;

implementation

uses Messages,
  doomdef, d_main,
  i_input, i_system,
  m_argv;

function WindowProc(hWnd: HWND; Msg: UINT; wParam: WPARAM;
  lParam: LPARAM): LRESULT; stdcall; export;
begin
  if not I_GameFinished then
  begin
    case Msg of
      WM_SETCURSOR:
        begin
          SetCursor(0);
        end;
      WM_SYSCOMMAND:
        begin
          if (wParam = SC_SCREENSAVE) then
          begin
            result := 0;
            exit;
          end;
        end;
      WM_ACTIVATE:
        begin
          I_SynchronizeInput(wparam <> WA_INACTIVE);
        end;
      WM_CLOSE:
        begin
          result := 0; // Preserve closing window by pressing Alt + F4
          exit;
        end;
      WM_DESTROY:
        begin
          I_Destroy(0);
        end;
    end;
  end;

  result := DefWindowProc(hWnd, Msg, WParam, LParam);
end;

procedure DoomMain;
var
  WindowClass: TWndClass;
begin
  ZeroMemory(WindowClass, SizeOf(WindowClass));
  WindowClass.lpfnWndProc := @WindowProc;
  WindowClass.hbrBackground := GetStockObject(WHITE_BRUSH);
  WindowClass.lpszClassName := 'Doom32';
  if HPrevInst = 0 then
  begin
    WindowClass.hInstance := HInstance;
    WindowClass.hIcon := LoadIcon(HInstance, 'MAINICON');
    WindowClass.hCursor := LoadCursor(0, nil);
    if RegisterClass(WindowClass) = 0 then
      halt(1);
  end;
  hMainWnd := CreateWindowEx(
    CS_HREDRAW or CS_VREDRAW,
    WindowClass.lpszClassName,
    AppTitle,
    WS_OVERLAPPED,
    0,
    0,
    0,
    0,
    0,
    0,
    HInstance,
    nil);
  ShowWindow(hMainWnd, SW_SHOW{CmdShow});
  UpdateWindow(hMainWnd);
  D_DoomMain;
end;

end.
