// Doom to Delphi Total Conversion
// Author: Jim Valavanis
// E-Mail: jimmyvalavanis@yahoo.gr
// Site  : http://www.geocities.com/jimmyvalavanis/applications/delphidoom.html

unit m_argv;

interface

{
    m_argv.h, m_argv.c
}

// Emacs style mode select   -*- C++ -*-  
//----------------------------------------------------------------------------- 
// 
// $Id:$ 
// 
// Copyright (C) 1993-1996 by id Software, Inc. 
// 
// This source is available for distribution and/or modification 
// only under the terms of the DOOM Source Code License as 
// published by id Software. All rights reserved. 
// 
// The source is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// FITNESS FOR A PARTICULAR PURPOSE. See the DOOM Source Code License 
// for more details. 
// 
// DESCRIPTION: 
//  Nil. 
//     
//----------------------------------------------------------------------------- 

// 
// MISC 
//

const
  MAXARGS = 256;

var
  myargc: integer;
  myargv: array[0..MAXARGS] of string;

{ Returns the position of the given parameter }
{ in the arg list (0 if not found). }
function M_CheckParm(const check: string): integer;

function M_CheckParmCDROM: boolean;

procedure M_InitArgv;

implementation

uses d_delphi {$IFDEF DEBUG},classes{$ENDIF};

var
  cdchecked: integer = -1;

{$IFDEF DEBUG}
var
  cmdparams: TStringList;
{$ENDIF}

function M_CheckParm(const check: string): integer;
var
  i: integer;
begin
{$IFDEF DEBUG}
  if cmdparams.IndexOf(check) < 0 then
    cmdparams.Add(check);
{$ENDIF}
  for i := 1 to myargc - 1 do
    if strupper(check) = myargv[i] then
    begin
      result := i;
      exit;
    end;
  result := 0;
end;

function M_CheckParmCDROM: boolean;
begin
  if cdchecked = -1 then
  begin
    cdchecked := M_CheckParm('-cdrom');
    {$I-}
    if cdchecked > 0 then
      MkDir('c:\doomdata');
    {$I+}
  end;
  result := cdchecked > 0;
end;

procedure M_InitArgv;
var
  i: integer;
begin
  myargc := ParamCount + 1;
  for i := 0 to myargc - 1 do
    myargv[i] := strupper(ParamStr(i));
  for i := myargc to MAXARGS do
    myargv[i] := '';
end;

initialization
{$IFDEF DEBUG}
  cmdparams := TStringList.Create;
{$ENDIF}

finalization
{$IFDEF DEBUG}
  cmdparams.SaveToFile('cmdparams.txt');
  cmdparams.Free;
{$ENDIF}

end.

